require_relative 'player'
require_relative 'treasure_trove'

module StudioGame
  class ClumsyPlayer < Player
  	def initialize(name, health=100)
  		super(name, health)
  		@clumsiness = 2
      @health_bonus = 20
  	end
  	def broken_treasure_points(treasure)
  		treasure.points / @clumsiness
  	end
  	def found_treasure(treasure)
  		super(Treasure.new(treasure.name, broken_treasure_points(treasure)))
  	end
    def w00t
      @health += @health_bonus
      super
      puts "#{@name} got a health bonus of #{@health_bonus} for being clumsy!"
    end
  end

  if __FILE__ == $0
    clumsy = ClumsyPlayer.new("klutz")  
    
    hammer = Treasure.new(:hammer, 50)
    clumsy.found_treasure(hammer)
    clumsy.found_treasure(hammer)
    clumsy.found_treasure(hammer)
    
    crowbar = Treasure.new(:crowbar, 400)
    clumsy.found_treasure(crowbar)
    
    clumsy.each_found_treasure do |treasure|
      puts "#{treasure.points} total #{treasure.name} points"
    end
    puts "#{clumsy.points} grand total points"
  end
end